import java.util.Vector;

class MyTag_reverse {
	String tagSeq = "";
	int frequence = 0;
	String qv = "";
	
	//for SOLiD 
	String firstBase = "";
	
	MyTag_reverse(String t){
		String[] ts = t.split("\t");		
		tagSeq = ts[0];
		if(ts.length==2){
			frequence = Integer.parseInt(ts[1]);
		}
		else if(ts.length==3){
			qv = (ts[1]);
			frequence = Integer.parseInt( ts[2]);
		}
	}
	
    //for SOLiD
	MyTag_reverse(String t, String f){
		String[] ts = t.split("\t");		
		tagSeq = ts[0];
		if(ts.length==2){
			frequence = Integer.parseInt(ts[1]);
		}
		else if(ts.length==3){
			qv = (ts[1]);
			frequence = Integer.parseInt( ts[2]);
		}
		firstBase = f;
	}	
}
class MyTagCluster_reverse {
	MyTag_reverse repTag;
	//Vector mismatch_tags;	
	
	int mismatch_tags_num = 0;
	int cluster_num = 1;
	int frequence_all = 0;
	
	String members ="";
	String all_members ="";
	int depth = 1;
	int depth_final = 1;
	int member_num_final = 1;
	
	MyTagCluster_reverse (String t){
		repTag = new MyTag_reverse(t);
		//mismatch_tags = new Vector();
		frequence_all = repTag.frequence;
        all_members = repTag.tagSeq;

	}
	//for SOLiD 
	MyTagCluster_reverse (String t,String f){
		repTag = new MyTag_reverse(t,f);
		//mismatch_tags = new Vector();
		frequence_all = repTag.frequence;
	}	
	
	String Print_final(){
		String[] m= members.split(" ");
		for(int i=0;i<m.length;i++){
			depth_final = Math.max(depth_final, m[i].split(">").length);
		}
		String line = "";
		line =  repTag.tagSeq +"\t"+ repTag.frequence +"\t"+ frequence_all +"\t"+ member_num_final +"\t"+depth_final +"\t"+ members;
		return line;
	}
	
	String Print_final_SOLiD(){
		String[] m= members.split(" ");
		for(int i=0;i<m.length;i++){
			depth_final = Math.max(depth_final, m[i].split(">").length);
		}
		String line = "";
		line =  repTag.firstBase+repTag.tagSeq +"\t"+ repTag.frequence +"\t"+ frequence_all +"\t"+ member_num_final +"\t"+depth_final +"\t"+ members;
		return line;
	}
	
	String Print_open(){
		String[] m= members.split(" ");
		for(int i=0;i<m.length;i++){
			depth_final = Math.max(depth_final, m[i].split(">").length);
		}
		String line = "";
		line =  repTag.tagSeq +"\t"+ repTag.frequence +"\t"+ frequence_all +"\t"+ member_num_final +"\t"+depth_final ;
		return line;
	}
}

class Record{
	String seq ;
	int num ; //position in vector of all the MyTagCluster_reverse
	Record(){		
	}
	Record(String a, int b){	
		seq = a;
		num = b;
	}
}
class Hash{
	static int BucketSize;
	static Vector[] Bucket;
	
	Hash(int size){
		BucketSize = size;
		Bucket = new Vector[BucketSize];
		for(int n=0;n<BucketSize;n++){
			Bucket[n] =  new Vector();
		}
	}

	static int C2I(char c){
		return c-' '+1;
	}
	
	static int LinearProblingHashValue(String s){
		int h =0;
		int length = s.length();
		for(int n=0;n<length;n++){
			int v =C2I(s.charAt(n));
			h = (32*h+v)%BucketSize;
		}
		return h;
	}
	
	public void LinearProblingInsert(String a, int b){
		int h;
		h = LinearProblingHashValue(a);
		Bucket[h].add(new Record(a,b));
	}
	
	public Record LinearProblingSearch(String k){
		int h;int flag=0;
		h = LinearProblingHashValue(k);
		int num = Bucket[h].size();
		Record tmp =null;
		
		for(int i=0;i<num;i++){
			tmp = (Record)Bucket[h].get(i);
			if(tmp.seq.equals(k)){
				flag=1;												
				break;}
		}					
		if(flag==1)
			{
			return tmp;					    
			}		
		else
			return null;
	}
}	
